/*
 * Sketch: ESP8266_Part9_01_Websocket_LED
 * Intended to be run on an ESP8266
 */
#include "webpage.h"
#include <ESP8266WiFi.h>
#include <WebSocketsServer.h>
#include <Adafruit_NeoPixel.h>

WiFiServer server(80);
WebSocketsServer webSocket = WebSocketsServer(81);

Adafruit_NeoPixel pixels(8, 4, NEO_GRB + NEO_KHZ800);
int i;

char ssid[] = "link";  // use your own network ssid and password
char pass[] = "nidieunimaitre";
 
void setup()
{
  
  pixels.begin();
 
  Serial.begin(9600);
  Serial.println();
  Serial.println("Serial started at 9600");
  Serial.println();
 
  // Connect to a WiFi network
  Serial.print(F("Connecting to "));  Serial.println(ssid);
  WiFi.begin(ssid,pass);
 
  // connection with timeout
  int count = 0; 
  while ( (WiFi.status() != WL_CONNECTED) && count < 17) 
  {
      Serial.print(".");  delay(500);  count++;
  }
 
  if (WiFi.status() != WL_CONNECTED)
  { 
     Serial.println("");  Serial.print("Failed to connect to ");  Serial.println(ssid);
     while(1);
  }
 
  Serial.println("");
  Serial.println(F("[CONNECTED]"));   Serial.print("[IP ");  Serial.print(WiFi.localIP()); 
  Serial.println("]");
 
  // start a server
  server.begin();
  Serial.println("Server started");
 
  webSocket.begin();
  webSocket.onEvent(webSocketEvent);
}
 
void loop()
{
    webSocket.loop();
 
    WiFiClient client = server.available();     // Check if a client has connected
    if (!client)  {  return;  }
 
    client.flush();
    client.print( header );
    client.print( html_1 ); 
    Serial.println("New page served");
 
    delay(5);
}
 
void webSocketEvent(byte num, WStype_t type, uint8_t * payload, size_t length)
{

  if(type == WStype_TEXT)
  {
      if (payload[0] == '0')
      {
              for (i = 0; i <= 7; i++) {
                  pixels.setPixelColor(i, pixels.Color(0,255,120));
              }
              pixels.show();      
      }
      else if (payload[0] == '1')
      {
              for (i = 0; i <= 7; i++) {
                  pixels.setPixelColor(i, pixels.Color(255,255,255));
              }
              pixels.show();    
      }
  }
 
  else 
  {
    Serial.print("WStype = ");   Serial.println(type);  
    Serial.print("WS payload = ");
    for(int i = 0; i < length; i++) { Serial.print((char) payload[i]); }
    Serial.println();
 
  }
}
